/*

Copyright (c) 2011 braincopy.org

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION 
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

 */

package org.braincopy.jspwiki.plugin;

import java.util.Map;

import com.ecyrd.jspwiki.WikiContext;
import com.ecyrd.jspwiki.plugin.PluginException;
import com.ecyrd.jspwiki.plugin.WikiPlugin;

public class OSM implements WikiPlugin
{

    /*
     * (non-Javadoc)
     * @see com.ecyrd.jspwiki.plugin.WikiPlugin#execute(com.ecyrd.jspwiki.WikiContext, java.util.Map)
     */
    public String execute( WikiContext context, Map params ) throws PluginException
    {
        double latitude = 35.684444;
        if(params.get( "lat" )!=null)
            latitude=Double.parseDouble( (String)params.get( "lat" ));

        double longtitude = 139.77437;
        if(params.get( "lng" )!=null)
            longtitude = Double.parseDouble( (String)params.get( "lng" ));

        int zoom = 15;
        if(params.get( "zoom" )!=null)
            zoom = Integer.parseInt( ( String)params.get( "zoom" ));
        
        int width = 400;
        if(params.get( "width" )!=null)
            width = Integer.parseInt( (String )params.get( "width" ));

        int height = 400;
        if(params.get( "height" )!=null)
            width = Integer.parseInt( (String )params.get( "height" ));

        String result ="";
        result += "  <div id=\"demoMap\" style=\"width: "+width+"px; height: "+height+"px\"></div>\n";
        result += "<script src=\"http://www.openlayers.org/api/OpenLayers.js\"></script>\n";
        result += "<script>\n";
        result += " map = new OpenLayers.Map(\"demoMap\");\n";
        result += " layer = new OpenLayers.Layer.OSM();\n";
        result += " map.addLayer(layer);\n";
        result += " var markers = new OpenLayers.Layer.Markers(\"Markers\");\n";
        result += " map.addLayer(markers);\n";
        result += " var lonLat = new OpenLayers.LonLat("+longtitude +","+latitude+");\n";
        result += " markers.addMarker(new OpenLayers.Marker(lonLat));\n"; 
        result += "map.setCenter(lonLat.transform(\n";
        result += " new OpenLayers.Projection(\"EPSG:4326\"),\n"; // transform from WGS 1984
        result += " new OpenLayers.Projection(\"EPSG:900913\")\n"; // to Spherical Mercator Projection
        result += " ), "+zoom+"\n"; // Zoom level
        result += " );\n";
//        result += "map.zoomToMaxExtent();\n";
        result += "</script>\n";

        return result;
    }

}
